// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 13 1.4.1.3 source/core/collect/iabag.inl, collection, ioc.v400, trackPseudoLevel  
#ifndef _IABAG_INL_
#define _IABAG_INL_

// ---
// IABag
// ---

#include <ilanglvl.hpp>


template <class Element>
inline
IABag <Element>::
IABag (INotifier& notifier)
{ this->SetImpl ((Implementation*)&notifier);
}


template <class Element>
inline
IABag <Element>::
~IABag ()
{
}

template <class Element>
inline void
IABag <Element>::
addDifference (IABag <Element> const& collection1,
               IABag <Element> const& collection2)
{ this->ImplOf (*this).
    AddDifference (this->ImplOf (collection1), this->ImplOf (collection2));
}

template <class Element>
inline void
IABag <Element>::
addIntersection (IABag <Element> const& collection1,
                 IABag <Element> const& collection2)
{ this->ImplOf (*this).
    AddIntersection (this->ImplOf (collection1), this->ImplOf (collection2));
}

template <class Element>
inline void
IABag <Element>::
addUnion (IABag <Element> const& collection1,
          IABag <Element> const& collection2)
{ this->ImplOf (*this).
    AddUnion (this->ImplOf (collection1), this->ImplOf (collection2));
}

template <class Element>
inline void
IABag <Element>::
differenceWith (IABag <Element> const& collection)
{ this->ImplOf (*this).Difference (this->ImplOf (collection));
}

template <class Element>
inline void
IABag <Element>::
intersectionWith (IABag <Element> const& collection)
{ this->ImplOf (*this).Intersection (this->ImplOf (collection));
}

template <class Element>
inline INumber
IABag <Element>::
numberOfDifferentElements () const
{ return this->ImplOf (*this).NumberOfDifferentElements ();
}

template <class Element>
inline IBool
IABag <Element>::
setToNextDifferentElement (ICursor& cursor) const
{ return this->ImplOf (*this).SetToNextDifferentElement (this->CrsrImplOf (cursor));
}

template <class Element>
inline void
IABag <Element>::
unionWith (IABag <Element> const& collection)
{ this->ImplOf (*this).Union (this->ImplOf (collection));
}

template <class Element>
inline IBool
IABag <Element>::
operator== (IABag <Element> const& collection) const
{ return this->ImplOf (*this).operator== (this->ImplOf (collection));
}

template <class Element>
inline IBool
IABag <Element>::
operator!= (IABag <Element> const& collection) const
{ return this->ImplOf (*this).operator!= (this->ImplOf (collection));
}

// protected members

template <class Element>
inline
IABag <Element>::
IABag ()
{
}

template <class Element>
inline
IABag <Element>::
IABag (IABag <Element> const& collection)
: Inherited (collection)
{
}

// private members

template <class Element>
inline TYPENAME IABag <Element>::Implementation&
IABag <Element>::
ImplOf (IABag <Element> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

#endif // _IABAG_INL_
