// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 70 1.4.1.2 source/core/collect/iaseq.inl, collection, ioc.v400, 981126  
#ifndef _IASEQ_INL_
#define _IASEQ_INL_

// ---
// IASequence
// ---

#include <ilanglvl.hpp>


template <class Element>
inline
IASequence <Element>::
IASequence (INotifier& notifier)
{ this->SetImpl ((Implementation*)&notifier);
}


template <class Element>
inline
IASequence <Element>::
~IASequence ()
{
}

template <class Element>
inline long
IASequence <Element>::
compare (IASequence <Element> const& collection,
         long (*compFunc) (Element const&, Element const&)) const
{ return this->ImplOf (*this).
    Compare (this->ImplOf (collection), (ICompFunc)compFunc, 0);
}

// protected members

template <class Element>
inline
IASequence <Element>::
IASequence ()
{
}

template <class Element>
inline
IASequence <Element>::
IASequence (IASequence <Element> const& collection)
: Inherited (collection)
{
}

// private members

template <class Element>
inline TYPENAME IASequence <Element>::Implementation&
IASequence <Element>::
ImplOf (IASequence <Element> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

#endif // _IASEQ_INL_
