/*
*****************************************************************************************
*                                                                                       *
* COPYRIGHT:                                                                            *
*   IBM Open Class Library                                                              *
*   (C) Copyright International Business Machines Corporation,  1997                    *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.                  *
*                                                                                       *
*****************************************************************************************
*/
// Revision: 62 1.8.5.3 source/core/streams/igstream.inl, oss, ioc.v400, 981126 
//
//
//
// igstream.inl
//
#ifndef _IGSTREAM_INL_
#define _IGSTREAM_INL_

#include <idatstrm.hpp>
#include <imstrmbl.hpp>

inline void operator<<=(IMStreamable& object, IDataStream& s)
{
        object.internalizeFromStream(s);
}

inline void operator<<=(char& c, IDataStream& s)
{
        c = s.readByte();
}

inline void operator<<=(signed char& c, IDataStream& s)
{
        c = (signed char) s.readByte();
}

inline void operator<<=(unsigned char& c, IDataStream& s)
{
        c = (unsigned char) s.readByte();
}

inline void operator<<=(short& c, IDataStream& s)
{
        c = s.readShort();
}

inline void operator<<=(unsigned short& c, IDataStream& s)
{
        c = (unsigned short) s.readShort();
}

inline void operator<<=(long& c, IDataStream& s)
{
        c = s.readLong();
}

inline void operator<<=(unsigned long& c, IDataStream& s)
{
        c = (unsigned long) s.readLong();
}

inline void operator<<=(float& c, IDataStream& s)
{
        c = s.readFloat();
}

inline void operator<<=(double& c, IDataStream& s)
{
        c = s.readDouble();
}

inline void operator>>=(const IMStreamable& object, IDataStream& s)
{
        object.externalizeToStream(s);
}

inline void operator>>=(char c, IDataStream& s)
{
        s.writeByte(c);
}

inline void operator>>=(signed char c, IDataStream& s)
{
        s.writeByte((char) c);
}

inline void operator>>=(unsigned char c, IDataStream& s)
{
        s.writeByte((char) c);
}

inline void operator>>=(short c, IDataStream& s)
{
        s.writeShort(c);
}

inline void operator>>=(unsigned short c, IDataStream& s)
{
        s.writeShort((short) c);
}

inline void operator>>=(long c, IDataStream& s)
{
        s.writeLong(c);
}

inline void operator>>=(unsigned long c, IDataStream& s)
{
        s.writeLong((long) c);
}

inline void operator>>=(float c, IDataStream& s)
{
        s.writeFloat(c);
}

inline void operator>>=(double c, IDataStream& s)
{
        s.writeDouble(c);
}

#endif // _IGSTREAM_INL_
