// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 33 1.5.1.4 source/core/collect/iicmwt.h, collection, ioc.v400, trackPseudoLevel 
#ifndef _IICMWT_
#define _IICMWT_

#include <ilanglvl.hpp>
#include <iimwt.h>










#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)


#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class CInherited>
class IC_EXPORTC ICMultiwayTreeImpl : public CInherited 
{
public:

  typedef TYPENAME CInherited::Ops Ops;

           ICMultiwayTreeImpl
                            (Ops&);

           ICMultiwayTreeImpl
                            (Ops&,
                             ICMultiwayTreeImpl <CInherited> const&);

  void     AddAsChild       (ITreeCursorImpl const&,
                             IPosition, void const*);

  void     AddAsRoot        (void const*);

  IBool AllSubtreeElementsDo
                            (ITreeCursorImpl const&, IApplFunc,
                             ITreeIterationOrder, void*);

  void     AttachAsChild    (ITreeCursorImpl const&,
                             IPosition, IMultiwayTreeImpl&);

  void     AttachAsRoot     (IMultiwayTreeImpl&);

  void     AttachSubtreeAsChild
                            (ITreeCursorImpl const&, IPosition,
                             IMultiwayTreeImpl&,
                             ITreeCursorImpl const&);

  void     AttachSubtreeAsRoot
                            (IMultiwayTreeImpl&,
                             ITreeCursorImpl const&);

  IPosition
           ChildPositionAt  (ITreeCursorImpl const&) const;
  
  void     CopySubtree      (IMultiwayTreeImpl const&,
                             ITreeCursorImpl const&);

  void*    ElementAt        (ITreeCursorImpl const&) const;

  IBool HasChild         (IPosition, ITreeCursorImpl const&) const;

  IBool IsLeaf           (ITreeCursorImpl const&) const;

  IBool IsRoot           (ITreeCursorImpl const&) const;

  INumber  NumberOfSubtreeElements
                            (ITreeCursorImpl const&) const;


  INumber  NumberOfSubtreeLeaves
                            (ITreeCursorImpl const&) const;

  INumber  RemoveSubtree    (ITreeCursorImpl&);

  void     ReplaceAt        (ITreeCursorImpl const& cursor,
                             void const*);

  IBool SetToChild       (IPosition, ITreeCursorImpl&) const;

  IBool SetToFirst       (ITreeCursorImpl&,
                             ITreeIterationOrder) const;

  IBool SetToFirstExistingChild
                            (ITreeCursorImpl&) const;

  IBool SetToLast        (ITreeCursorImpl&,
                             ITreeIterationOrder) const;

  IBool SetToLastExistingChild
                            (ITreeCursorImpl&) const;

  IBool SetToNext        (ITreeCursorImpl&,
                             ITreeIterationOrder) const;

  IBool SetToNextExistingChild
                            (ITreeCursorImpl&) const;

  IBool SetToParent      (ITreeCursorImpl&) const;

  IBool SetToPrevious    (ITreeCursorImpl&,
                             ITreeIterationOrder) const;

  IBool SetToPreviousExistingChild
                            (ITreeCursorImpl&) const;

  IBool SetToRoot        (ITreeCursorImpl&) const;

protected:

private:












};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif








#if ! defined (__TEMPINC__)
#include <iicmwt.c>
#endif



#pragma info (restore)


#endif // _IICMWT_
