// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 08 1.5.1.2 source/core/collect/iiksbtab.c, collection, ioc.v400, 981126 
#ifndef _IIKSBTAB_C_
#define _IIKSBTAB_C_


#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)


// ---
// IKeySortedBagAsTableOps
// ---

// public members

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySortedBagAsTableOps <Element, Key, ElementOps, Implementation>::
IKeySortedBagAsTableOps (INumber numberOfElements)
: ivElementOps (),
  ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySortedBagAsTableOps <Element, Key, ElementOps, Implementation>::
IKeySortedBagAsTableOps (INumber numberOfElements, void* opsArg)
: ivElementOps (opsArg),
  ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class _Key,
          class ElementOps, class Implementation>
IKeySortedBagAsTableOps <Element, _Key, ElementOps, Implementation>::
IKeySortedBagAsTableOps
  (IKeySortedBagAsTableOps
    <Element, _Key, ElementOps, Implementation> const& collection)
: ivElementOps (collection.ivElementOps),
  ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySortedBagAsTableOps <Element, Key, ElementOps, Implementation>::
~IKeySortedBagAsTableOps ()
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IACollectionImpl*
IKeySortedBagAsTableOps <Element, Key, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class _Key,
          class ElementOps, class Implementation>
long
IKeySortedBagAsTableOps <Element, _Key, ElementOps, Implementation>::
CompareKeys (void const* arg1, void const* arg2, IArgType argType) const
{ long comp = 0;
  switch (argType) {
    case kElementElement: {
      comp = ivElementOps.keyOps.Compare
        (ivElementOps.Key (*(Element const*)arg1),
         ivElementOps.Key (*(Element const*)arg2));
      break;
    }
    case kElementKey: {
      comp = ivElementOps.keyOps.Compare
        (ivElementOps.Key (*(Element const*)arg1),
         IKeyForOps ((_Key const*)arg2));
      break;
    }
    case kKeyKey: {
      comp = ivElementOps.keyOps.Compare
        (IKeyForOps ((_Key const*)arg1), IKeyForOps ((_Key const*)arg2));
    }
  }
  return comp;
}

template <class Element, class _Key,
          class ElementOps, class Implementation>
void*
IKeySortedBagAsTableOps <Element, _Key, ElementOps, Implementation>::
Key (void const* element) const
{ return IKeyFromOps (ivElementOps.Key (*(Element const*)element));
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySortedBagAsTableOps <Element, Key, ElementOps, Implementation>::
operator ISequenceAsTableImpl& ()
{ return *(ISequenceAsTableImpl*)ivBase;
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IKeySortedBagAsTableOps <Element, Key, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl;
}


#pragma info (restore)


#endif // _IIKSBTAB_C_
