// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 21 1.6.1.4 source/core/collect/iikskss.h, collection, ioc.v400, trackPseudoLevel 
#ifndef _IIKSKSS_
#define _IIKSKSS_

#include <ilanglvl.hpp>
#include <iiaks.h>







#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)










#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

template <class Base>
class IKeySetOnKeySortedSetMngCursorImpl;

template <class Base>
class IKeySetOnKeySortedSetImpl;

#pragma pack(push,4)
#pragma enum(4)

template <class Base>
class IC_EXPORTC IKeySetOnKeySortedSetMngCursorImpl : public Base::MngCursor
{
  typedef TYPENAME Base::MngCursor Inherited;

public:

           IKeySetOnKeySortedSetMngCursorImpl
                            (IKeySetOnKeySortedSetImpl <Base> const&);

          ~IKeySetOnKeySortedSetMngCursorImpl
                            ();

protected:

private:









};

template <class Base>
class IBagOnKeySetImpl;

template <class Base>
class IAKeySetOnKeySortedSetOps;

template <class Base>
class IC_EXPORTC IKeySetOnKeySortedSetImpl : public IAKeySetImpl {

  typedef  IAKeySetImpl Inherited;

  typedef  IKeySetOnKeySortedSetImpl <Base> Self;

public:

  typedef  IAKeySetOnKeySortedSetOps <Base> Ops;

  typedef TYPENAME Base::Cursor Cursor;

  typedef  IKeySetOnKeySortedSetMngCursorImpl <Base> MngCursor;

           IKeySetOnKeySortedSetImpl
                            (Ops&, INumber);

           IKeySetOnKeySortedSetImpl
                            (Ops&,
                             IKeySetOnKeySortedSetImpl <Base> const&);

          ~IKeySetOnKeySortedSetImpl
                            ();

  IBool Add              (void const*, ICursorImpl&);

  void     AddAllFrom       (IACollectionImpl const&);

  IBool AddOrReplaceElementWithKey
                            (void const*, ICursorImpl&);

  IBool AllElementsDo    (IApplFunc, void*);

  void*    Any              () const;

  IBool CheckCursor      (ICursorImpl const&) const;

  IBool CheckReplacement (ICursorImpl const&, void const* ) const;

  char const*
           ClassName        () const;

  IACollectionImpl*
           Clone            () const;

  IBool ContainsAllKeysFrom
                            (IACollectionImpl const&) const;

  IBool ContainsElementWithKey
                            (void const*) const;

  void     Copy             (IACollectionImpl const&);

  Cursor*  CreateCursor     () const;

  MngCursor*
           CreateMngCursor  () const;

  void*    ElementAt        (ICursorImpl const&) const;

  void*    ElementWithKey   (void const*) const;

  IBool IsBounded        () const;

  IBool IsConsistent     () const;

  IBool IsEmpty          () const;

  IBool IsFull           () const;

  void*    Key              (void const*) const;

  IBool LocateElementWithKey
                            (void const*, ICursorImpl&) const;

  IBool LocateOrAddElementWithKey
                            (void const*, ICursorImpl&);

  INumber  NumberOfElements () const;

  INumber  RemoveAll        ();

  INumber  RemoveAll        (IPredFunc, void*);

  void     RemoveAt         (ICursorImpl&);

  IBool RemoveElementWithKey
                            (void const*);

  void     ReplaceAt        (ICursorImpl const&, void const*);

  IBool ReplaceElementWithKey
                            (void const*, ICursorImpl&);

  IBool SetToFirst       (ICursorImpl&) const;

  IBool SetToNext        (ICursorImpl&) const;

  void     operator=        (IKeySetOnKeySortedSetImpl <Base> const&);

protected:

  IBool EqualKeys        (void const*, void const*, IArgType) const;

private:

  static
  char const*
           cvClassName;

  Base&    ivBase;

  static
  Base&    BaseOf           (IKeySetOnKeySortedSetImpl <Base> const&);

  static
  Ops&     OpsOf            (IKeySetOnKeySortedSetImpl <Base> const&);

  friend
  class    IKeySetOnKeySortedSetMngCursorImpl <Base>;

  friend
  class    IKeySetOnKeySortedSetImpl <Base>;

  friend
  class    IBagOnKeySetImpl <Self>;

#if ! defined (__INO_STREAMING__)
public:
  IStreamerPtr&
           StreamerOf       (IACollectionImpl const&);

  void     StreamIn         (IDataStream&);

  void     StreamOut        (IDataStream&) const;

  void     AdoptStreamer    (IACollectionStreamer*);
#endif





















};

template <class Base>
class IC_EXPORTC IAKeySetOnKeySortedSetOps 
{
public:

  virtual ~IAKeySetOnKeySortedSetOps
                            ();

  virtual
  IACollectionImpl*
           Clone            () const = 0;

  virtual  operator Base&   () = 0;

protected:

private:








};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif





#include <iikskss.inl>


#pragma info (restore)


#endif // _IIKSKSS_
