// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 29 1.4.1.3 source/core/collect/iikssavl.inl, collection, ioc.v400, trackPseudoLevel 
#ifndef _IIKSSAVL_INL_
#define _IIKSSAVL_INL_

#include <iiexc.h>

// -------------------------------
// IAKeySortedSetAsAvlTreeNodeImpl
// -------------------------------

// public members

inline
IAKeySortedSetAsAvlTreeNodeImpl::
IAKeySortedSetAsAvlTreeNodeImpl ()
: ivLeft (0), ivRight (0), ivParent (0), ivDeeperSubtree (kAvlNone)
{
}

// ------------------------------
// IKeySortedSetAsAvlTreeNodeImpl
// ------------------------------

// public members

template <class Element>
inline
IKeySortedSetAsAvlTreeNodeImpl <Element>::
IKeySortedSetAsAvlTreeNodeImpl (Element const& element)
: IAKeySortedSetAsAvlTreeNodeImpl (), ivElement (element)
{
}

template <class Element>
inline
IKeySortedSetAsAvlTreeNodeImpl <Element>::
~IKeySortedSetAsAvlTreeNodeImpl ()
{
}

#if ! defined(__INO_STREAMING__)
template <class Element>
inline void
IKeySortedSetAsAvlTreeNodeImpl <Element>::
StreamIn (IACollectionStreamer *streamer, IDataStream& fromWhere)
{ ivLeft = ivRight = ivParent = 0;
  ivDeeperSubtree = kAvlNone;
  streamer->streamIn (fromWhere, &ivElement);
}
#endif

// --------------------------------
// IKeySortedSetAsAvlTreeCursorImpl
// --------------------------------

// public members

inline void
IKeySortedSetAsAvlTreeCursorImpl::
Invalidate ()
{ ivNode = 0;
}

inline IBool
IKeySortedSetAsAvlTreeCursorImpl::
IsInBetween () const
{ return false;
}

inline IBool
IKeySortedSetAsAvlTreeCursorImpl::
IsValid () const
{ return (ivNode != 0);
}

inline void
IKeySortedSetAsAvlTreeCursorImpl::
operator= (IKeySortedSetAsAvlTreeCursorImpl const& cursor)
{ Inherited::operator= (cursor);
  ivNode = cursor.ivNode;
}

inline IBool
IKeySortedSetAsAvlTreeCursorImpl::
operator== (ICursorImpl const& cursor) const
{ return (Inherited::operator== (cursor) &&
          ivNode == ((Self const&)cursor).ivNode);
}


// --------------------------
// IAKeySortedSetAsAvlTreeOps
// --------------------------

// public members

inline
IAKeySortedSetAsAvlTreeOps::
~IAKeySortedSetAsAvlTreeOps ()
{
}

// protected members

inline
IAKeySortedSetAsAvlTreeOps::
IAKeySortedSetAsAvlTreeOps (IBool containsDTSObjects)
: ivContainsDTSObjects (containsDTSObjects)
{
}

#endif // _IIKSSAVL_INL_
