// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 33 1.4.1.3 source/core/collect/iikssbst.inl, collection, ioc.v400, trackPseudoLevel 
#ifndef _IIKSSBST_INL_
#define _IIKSSBST_INL_

#include <iiexc.h>

// --------------------------------
// IAKeySortedSetAsBstTreeINodeImpl
// --------------------------------

// public members

inline
IAKeySortedSetAsBstTreeINodeImpl::
IAKeySortedSetAsBstTreeINodeImpl ()
: ivm (0)
{
}

inline
IAKeySortedSetAsBstTreeINodeImpl::
IAKeySortedSetAsBstTreeINodeImpl
  (IAKeySortedSetAsBstTreeINodeImpl const& inode)
: ivm (inode.ivm)
{
}

// -------------------------------
// IKeySortedSetAsBstTreeINodeImpl
// -------------------------------

// public members

template <class Key, size_t nodeSize>
inline
IKeySortedSetAsBstTreeINodeImpl <Key, nodeSize>::
IKeySortedSetAsBstTreeINodeImpl ()
{ ivIsLeaf = false;
  Inherited::ivPtrs = ivPtrs;
  Inherited::ivKeys = ivKeys;
}

template <class Key, size_t nodeSize>
inline
IKeySortedSetAsBstTreeINodeImpl <Key, nodeSize>::
IKeySortedSetAsBstTreeINodeImpl
  (IKeySortedSetAsBstTreeINodeImpl <Key, nodeSize > const& inode)
: Inherited (inode)
{ ivIsLeaf = false;
  Inherited::ivPtrs = ivPtrs;
  Inherited::ivKeys = ivKeys;
}

template <class Key, size_t nodeSize>
inline
IKeySortedSetAsBstTreeINodeImpl <Key, nodeSize>::
~IKeySortedSetAsBstTreeINodeImpl ()
{
}

// -------------------------------
// IKeySortedSetAsBstTreeLNodeImpl
// -------------------------------

// public members

template <class Element>
inline
IKeySortedSetAsBstTreeLNodeImpl <Element>::
IKeySortedSetAsBstTreeLNodeImpl (Element const& element)
: ivElement (element)
{ ivIsLeaf = true;
}

#if ! defined(__INO_STREAMING__)
template <class Element>
inline void
IKeySortedSetAsBstTreeLNodeImpl <Element>::
StreamIn (IACollectionStreamer *streamer, IDataStream& fromWhere)
{ ivIsLeaf = true;
  streamer->streamIn (fromWhere, &ivElement);
}
#endif

template <class Element>
inline
IKeySortedSetAsBstTreeLNodeImpl <Element>::
~IKeySortedSetAsBstTreeLNodeImpl ()
{
}

// --------------------------------
// IKeySortedSetAsBstTreeCursorImpl
// --------------------------------

// public members

inline void
IKeySortedSetAsBstTreeCursorImpl::
Invalidate ()
{ ivNode = 0;
}

inline IBool
IKeySortedSetAsBstTreeCursorImpl::
IsValid () const
{ return (ivNode != 0);
}

inline IBool
IKeySortedSetAsBstTreeCursorImpl::
IsInBetween () const
{ return false;
}

inline void
IKeySortedSetAsBstTreeCursorImpl::
operator= (IKeySortedSetAsBstTreeCursorImpl const& cursor)
{ Inherited::operator= (cursor);
  ivNode = cursor.ivNode;
}

inline IBool
IKeySortedSetAsBstTreeCursorImpl::
operator== (ICursorImpl const& cursor) const
{ return (Inherited::operator== (cursor) &&
          ivNode == ((Self const&)cursor).ivNode);
}


// --------------------------
// IAKeySortedSetAsBstTreeOps
// --------------------------

// public members

inline
IAKeySortedSetAsBstTreeOps::
~IAKeySortedSetAsBstTreeOps ()
{
}

// protected members

inline
IAKeySortedSetAsBstTreeOps::
IAKeySortedSetAsBstTreeOps (IBool containsDTSObjects)
: ivContainsDTSObjects (containsDTSObjects)
{
}

#endif // _IIKSSBST_INL_
