// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 73 1.4.1.3 source/core/collect/iimwt.inl, collection, ioc.v400, trackPseudoLevel 
#ifndef _IIMWT_INL_
#define _IIMWT_INL_

// ---------------------
// IMultiwayTreeNodeImpl
// ---------------------

// public members

template <INumber numOfChildren, class Element>
inline
IMultiwayTreeNodeImpl <numOfChildren, Element>::
IMultiwayTreeNodeImpl (Element const& element)
: ivElement (element)
{ Inherited::ivParent = 0;
  Inherited::ivChildren = ivChildren;
}

template <INumber numOfChildren, class Element>
inline
IMultiwayTreeNodeImpl <numOfChildren, Element>::
~IMultiwayTreeNodeImpl ()
{
}

#if ! defined(__INO_STREAMING__)
template <INumber numOfChildren, class Element>
inline void
IMultiwayTreeNodeImpl<numOfChildren, Element>::
StreamIn (IACollectionStreamer *streamer, IDataStream& fromWhere)
{ Inherited::ivParent = 0;
  Inherited::ivChildren = ivChildren;
  streamer->streamIn (fromWhere, &ivElement);
}
#endif

// -----------------------
// IMultiwayTreeCursorImpl
// -----------------------

// public members

inline IBool
IMultiwayTreeCursorImpl::
IsValid () const
{ return (ivNode != 0);
}

inline void
IMultiwayTreeCursorImpl::
Invalidate ()
{ ivNode = 0;
}

inline void
IMultiwayTreeCursorImpl::
operator= (IMultiwayTreeCursorImpl const& cursor)
{ Inherited::operator= (cursor);
  ivNode = ((Self const&)cursor).ivNode;
}

inline IBool
IMultiwayTreeCursorImpl::
operator== (ITreeCursorImpl const& cursor) const
{ return (Inherited::operator== (cursor) &&
          ivNode == ((Self const&)cursor).ivNode);
}

// -----------------
// IAMultiwayTreeOps
// -----------------

// public members

inline
IAMultiwayTreeOps::
~IAMultiwayTreeOps ()
{
}

// protected members

inline
IAMultiwayTreeOps::
IAMultiwayTreeOps (IBool containsDTSObjects)
: ivContainsDTSObjects (containsDTSObjects)
{
}

#endif // _IIMWT_INL_
