// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 74 1.5.1.3 source/core/collect/iireldil.c, collection, ioc.v400, trackPseudoLevel 
#ifndef _IIRELDIL_C_
#define _IIRELDIL_C_


#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)


// ---
// IRelationAsDilTableOps
// ---

// public members

template <class Element, class Key,
          class ElementOps, class Implementation>
IRelationAsDilTableOps
 <Element, Key, ElementOps, Implementation>::
IRelationAsDilTableOps (INumber numberOfElements)
: ivElementOps (),
  ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IRelationAsDilTableOps
  <Element, Key, ElementOps, Implementation>::
IRelationAsDilTableOps (INumber numberOfElements, void* opsArg)
: ivElementOps (opsArg),
  ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IRelationAsDilTableOps
 <Element, Key, ElementOps, Implementation>::
IRelationAsDilTableOps
  (IRelationAsDilTableOps
    <Element, Key, ElementOps, Implementation> const& collection)
: ivElementOps (collection.ivElementOps),
  ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IRelationAsDilTableOps
 <Element, Key, ElementOps, Implementation>::
~IRelationAsDilTableOps ()
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IACollectionImpl*
IRelationAsDilTableOps
 <Element, Key, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IBool
IRelationAsDilTableOps
 <Element, Key, ElementOps, Implementation>::
EqualElements (void const* element1, void const* element2) const
{ return ivElementOps.Equal (*(Element const*)element1,
                             *(Element const*)element2);
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IRelationAsDilTableOps
 <Element, Key, ElementOps, Implementation>::
operator IKeyBagAsDilTableImpl& ()
{ return *(IKeyBagAsDilTableImpl*) ivBase;
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IRelationAsDilTableOps
 <Element, Key, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl;
}


#pragma info (restore)


#endif // _IIRELDIL_C_
