// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 19 1.4.1.2 source/core/collect/iisetdil.c, collection, ioc.v400, 981126 
#ifndef _IISETDIL_C_
#define _IISETDIL_C_


#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)


// ---
// ISetAsDilTableOps
// ---

// public members

template <class Element, class ElementOps, class Implementation>
ISetAsDilTableOps <Element, ElementOps, Implementation>::
ISetAsDilTableOps (INumber numberOfElements)
: ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISetAsDilTableOps <Element, ElementOps, Implementation>::
ISetAsDilTableOps (INumber numberOfElements, void* opsArg)
: ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISetAsDilTableOps <Element, ElementOps, Implementation>::
ISetAsDilTableOps
  (ISetAsDilTableOps
    <Element, ElementOps, Implementation> const& collection)
: ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class ElementOps, class Implementation>
ISetAsDilTableOps <Element, ElementOps, Implementation>::
~ISetAsDilTableOps ()
{
}

template <class Element, class ElementOps, class Implementation>
IACollectionImpl*
ISetAsDilTableOps <Element, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class ElementOps, class Implementation>
ISetAsDilTableOps <Element, ElementOps, Implementation>::
operator IKeySetAsDilTableImpl& ()
{ return *(IKeySetAsDilTableImpl*)ivBase ;
}

template <class Element, class ElementOps, class Implementation>
ISetAsDilTableOps <Element, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl ;
}


#pragma info (restore)


#endif // _IISETDIL_C_
