// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 90 1.3.1.4 source/core/collect/iivcllct.inl, collection, ioc.v400, trackPseudoLevel 
#ifndef _IIVCLLCT_INL_
#define _IIVCLLCT_INL_


#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)


// ---------------------
// IVCollectionEventData
// ---------------------

// public members

template <class Element>
inline
IVCollectionEventData <Element>::
IVCollectionEventData (ICursor const& cursor,
                       Element const* element)
: ivCursor (&cursor), ivElement (element)
{
}

template <class Element>
inline ICursor const&
IVCollectionEventData <Element>::
cursor () const
{ return *ivCursor;
}

template <class Element>
inline Element const*const
IVCollectionEventData <Element>::
element () const
{ return ivElement;
}

// ----------------
// IVCollectionImpl
// ----------------

// public members

inline INotifier&
IVCollectionImpl::
DisableNotification ()
{ return disableNotification ();
}

inline INotifier&
IVCollectionImpl::
EnableNotification (IBool enable)
{ return enableNotification (enable);
}

inline IBool
IVCollectionImpl::
IsEnabledForNotification () const
{ return isEnabledForNotification ();
}


#pragma info (restore)


#endif // _IIVCLLCT_INL_
