// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 41 1.4.1.4 source/core/collect/iksbdil.inl, collection, ioc.v400, 981126  
#ifndef _IKSBDIL_INL_
#define _IKSBDIL_INL_

// ---
// IGKeySortedBagAsDilTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class Key, class ElementOps>
inline
IGKeySortedBagAsDilTableCursor <Element, Key, ElementOps>::
IGKeySortedBagAsDilTableCursor
  (IGKeySortedBagAsDilTable
    <Element, Key, ElementOps> const& collection)
: IOrderedCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class Key, class ElementOps>
inline IGKeySortedBagAsDilTableCursor <Element, Key, ElementOps>&
IGKeySortedBagAsDilTableCursor <Element, Key, ElementOps>::
operator=
  (IGKeySortedBagAsDilTableCursor
    <Element, Key, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGKeySortedBagAsDilTableCursor <Element, Key, ElementOps>::
IGKeySortedBagAsDilTableCursor (ICursorImpl* impl)
: IOrderedCursor <Element> (impl)
{
}






























// ---
// IGKeySortedBagAsDilTable
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGKeySortedBagAsDilTable <Element, Key, ElementOps>::
IGKeySortedBagAsDilTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new




                Instantiation (numberOfElements));
}

template <class Element, class Key, class ElementOps>
inline
IGKeySortedBagAsDilTable <Element, Key, ElementOps>::
IGKeySortedBagAsDilTable
  (IGKeySortedBagAsDilTable
    <Element, Key, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class Key, class ElementOps>
inline IGKeySortedBagAsDilTable <Element, Key, ElementOps>&
IGKeySortedBagAsDilTable <Element, Key, ElementOps>::
operator= (IGKeySortedBagAsDilTable
            <Element, Key, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGKeySortedBagAsDilTable <Element, Key, ElementOps>::
IGKeySortedBagAsDilTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class Key, class ElementOps>
inline TYPENAME IGKeySortedBagAsDilTable
 <Element, Key, ElementOps>::Implementation&
IGKeySortedBagAsDilTable <Element, Key, ElementOps>::
ImplOf (IGKeySortedBagAsDilTable
         <Element, Key, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// IKeySortedBagAsDilTable
// ---

// public members

template <class Element, class Key>
inline
IKeySortedBagAsDilTable <Element, Key>::
IKeySortedBagAsDilTable (INumber numberOfElements)
: IGKeySortedBagAsDilTable
   <Element, Key, IKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IKeySortedBagAsDilTable <Element, Key>::
IKeySortedBagAsDilTable (PureImplementation& impl)
: IGKeySortedBagAsDilTable
   <Element, Key, IKCOps <Element, Key> > (impl)
{
}


// ---
// IVGKeySortedBagAsDilTable
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IVGKeySortedBagAsDilTable <Element, Key, ElementOps>::
IVGKeySortedBagAsDilTable (INumber numberOfElements)
: IGKeySortedBagAsDilTable
    <Element, Key, ElementOps> (*(Implementation*) *new




                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IVGKeySortedBagAsDilTable <Element, Key, ElementOps>::
IVGKeySortedBagAsDilTable (PureImplementation& impl)
: IGKeySortedBagAsDilTable
    <Element, Key, ElementOps> (impl)
{
}

// ---
// IVKeySortedBagAsDilTable
// ---

// public members

template <class Element, class Key>
inline
IVKeySortedBagAsDilTable <Element, Key>::
IVKeySortedBagAsDilTable (INumber numberOfElements)
: IVGKeySortedBagAsDilTable
   <Element, Key, IKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IVKeySortedBagAsDilTable <Element, Key>::
IVKeySortedBagAsDilTable (PureImplementation& impl)
: IVGKeySortedBagAsDilTable
   <Element, Key, IKCOps <Element, Key> > (impl)
{
}


#endif // _IKSBDIL_INL_
