// Revision: 17 1.4.1.4 source/multmed/immdevnh.hpp, multimedia, ioc.v400, trackPseudoLevel 
#ifndef _IMMDEVNH_
  #define _IMMDEVNH_
/*******************************************************************************
* FILE NAME: immdevnh.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IMMDeviceaNotifyHandler                                                  *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   Licensed Material - Property of IBM                                        *
*   (C) Copyright IBM Corp. 1992, 1997  All Rights Reserved.                   *
*                                                                              *
*******************************************************************************/
#include <iwinnhdr.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma enum(4)
#pragma pack(push,4)

#ifdef IC_PMWIN

class IMMDeviceNotifyHandler : public IWindowNotifyHandler {
typedef IWindowNotifyHandler
  Inherited;
public:
/*----------------------------- Constructors ---------------------------------*/
  IMMDeviceNotifyHandler();
virtual
  ~IMMDeviceNotifyHandler();

protected:
/*---------------------------- Event Processing ------------------------------*/
virtual IBool
  dispatchHandlerEvent (IEvent& anEvent);
IMMDeviceNotifyHandler*
  notificationHandler    ( ) const;
IMMDeviceNotifyHandler
 &setNotificationHandler (IMMDeviceNotifyHandler* notifyHandler);

private:
/*---------------------------- Hidden Functions ------------------------------*/
// Explicit copy CTOR, to avoid default inlining by compiler.
IMMDeviceNotifyHandler (const IMMDeviceNotifyHandler& handler);

};

#endif /* IC_PMWIN  */

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif /* _IMMDEVNH_ */
