// Revision: 53 1.3.1.2 source/multmed/immtime.inl, multimedia, ioc.v400, 981126 
#ifndef _IMMTIME_INL_
#define _IMMTIME_INL_
/*******************************************************************************
* FILE NAME: immtime.inl                                                       *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   classes declared in immtime.hpp                                            *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   Licensed Material - Property of IBM                                        *
*   (C) Copyright IBM Corp. 1992, 1997  All Rights Reserved.                   *
*                                                                              *
*******************************************************************************/

inline unsigned long IMMHourMinSecFrameTime::HourMinSecFrameToMM(unsigned long value, unsigned long fps)
{
  return ((((value) & 0x000000FFL) * 60L * 60L * 3000L) +
          (((value) & 0x0000FF00L) / 0x100L * 60L * 3000L) +
          (((value) & 0x00FF0000L) / 0x10000L * 3000L) +
          (((value) & 0xFF000000L) / 0x1000000L * 3000L/fps));
}

inline unsigned long IMMHourMinSecFrameTime::HourMinSecFrameFromMM(unsigned long value, unsigned long fps)
{
  return ((((value)+63L) >= 0x100UL*60UL*60UL*3000UL) ? 0L :
          (((((((value)+63L) % 3000L)/(3000L/fps))  << 24) & 0xFF000000L) |
           ((((((value)+63L) / 3000L) % 60L) << 16) & 0x00FF0000L)      |
          (((((((value)+63L) / 3000L) / 60L) % 60L) << 8) & 0x0000FF00L) |
           ((((((value)+63L) / 3000L) / 60L) / 60L)  & 0x000000FFL)));
}

#endif // _IMMTIME_INL_
