// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 45 1.4.1.4 source/core/collect/ireltab.inl, collection, ioc.v400, 981126  
#ifndef _IRELTAB_INL_
#define _IRELTAB_INL_

// ---
// IGRelationAsTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class Key, class ElementOps>
inline
IGRelationAsTableCursor <Element, Key, ElementOps>::
IGRelationAsTableCursor
  (IGRelationAsTable
    <Element, Key, ElementOps> const& collection)
: IElementCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class Key, class ElementOps>
inline IGRelationAsTableCursor <Element, Key, ElementOps>&
IGRelationAsTableCursor <Element, Key, ElementOps>::
operator=
  (IGRelationAsTableCursor
    <Element, Key, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGRelationAsTableCursor <Element, Key, ElementOps>::
IGRelationAsTableCursor (ICursorImpl* impl)
: IElementCursor <Element> (impl)
{
}






























// ---
// IGRelationAsTable
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGRelationAsTable <Element, Key, ElementOps>::
IGRelationAsTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new




                Instantiation (numberOfElements));
}

template <class Element, class Key, class ElementOps>
inline
IGRelationAsTable <Element, Key, ElementOps>::
IGRelationAsTable
  (IGRelationAsTable
    <Element, Key, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class Key, class ElementOps>
inline IGRelationAsTable <Element, Key, ElementOps>&
IGRelationAsTable <Element, Key, ElementOps>::
operator= (IGRelationAsTable
            <Element, Key, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGRelationAsTable <Element, Key, ElementOps>::
IGRelationAsTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class Key, class ElementOps>
inline TYPENAME IGRelationAsTable
 <Element, Key, ElementOps>::Implementation&
IGRelationAsTable <Element, Key, ElementOps>::
ImplOf (IGRelationAsTable
         <Element, Key, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// IRelationAsTable
// ---

// public members

template <class Element, class Key>
inline
IRelationAsTable <Element, Key>::
IRelationAsTable (INumber numberOfElements)
: IGRelationAsTable
   <Element, Key, IEKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IRelationAsTable <Element, Key>::
IRelationAsTable (PureImplementation& impl)
: IGRelationAsTable
   <Element, Key, IEKCOps <Element, Key> > (impl)
{
}


// ---
// IVGRelationAsTable
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IVGRelationAsTable <Element, Key, ElementOps>::
IVGRelationAsTable (INumber numberOfElements)
: IGRelationAsTable
    <Element, Key, ElementOps> (*(Implementation*) *new




                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IVGRelationAsTable <Element, Key, ElementOps>::
IVGRelationAsTable (PureImplementation& impl)
: IGRelationAsTable
    <Element, Key, ElementOps> (impl)
{
}

// ---
// IVRelationAsTable
// ---

// public members

template <class Element, class Key>
inline
IVRelationAsTable <Element, Key>::
IVRelationAsTable (INumber numberOfElements)
: IVGRelationAsTable
   <Element, Key, IEKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IVRelationAsTable <Element, Key>::
IVRelationAsTable (PureImplementation& impl)
: IVGRelationAsTable
   <Element, Key, IEKCOps <Element, Key> > (impl)
{
}


#endif // _IRELTAB_INL_
