// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 85 1.4.1.4 source/core/collect/isbbst.inl, collection, ioc.v400, 981126  
#ifndef _ISBBST_INL_
#define _ISBBST_INL_

// ---
// IGSortedBagAsBstTreeCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class ElementOps>
inline
IGSortedBagAsBstTreeCursor <Element, ElementOps>::
IGSortedBagAsBstTreeCursor
  (IGSortedBagAsBstTree
    <Element, ElementOps> const& collection)
: IOrderedCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class ElementOps>
inline IGSortedBagAsBstTreeCursor <Element, ElementOps>&
IGSortedBagAsBstTreeCursor <Element, ElementOps>::
operator=
  (IGSortedBagAsBstTreeCursor
    <Element, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGSortedBagAsBstTreeCursor <Element, ElementOps>::
IGSortedBagAsBstTreeCursor (ICursorImpl* impl)
: IOrderedCursor <Element> (impl)
{
}






























// ---
// IGSortedBagAsBstTree
// ---

// public members

template <class Element, class ElementOps>
inline
IGSortedBagAsBstTree <Element, ElementOps>::
IGSortedBagAsBstTree (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new




                Instantiation (numberOfElements));
}

template <class Element, class ElementOps>
inline
IGSortedBagAsBstTree <Element, ElementOps>::
IGSortedBagAsBstTree
  (IGSortedBagAsBstTree
    <Element, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class ElementOps>
inline IGSortedBagAsBstTree <Element, ElementOps>&
IGSortedBagAsBstTree <Element, ElementOps>::
operator= (IGSortedBagAsBstTree
            <Element, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGSortedBagAsBstTree <Element, ElementOps>::
IGSortedBagAsBstTree (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class ElementOps>
inline TYPENAME IGSortedBagAsBstTree
 <Element, ElementOps>::Implementation&
IGSortedBagAsBstTree <Element, ElementOps>::
ImplOf (IGSortedBagAsBstTree
         <Element, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// ISortedBagAsBstTree
// ---

// public members

template <class Element>
inline
ISortedBagAsBstTree <Element>::
ISortedBagAsBstTree (INumber numberOfElements)
: IGSortedBagAsBstTree
   <Element, ICOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
ISortedBagAsBstTree <Element>::
ISortedBagAsBstTree (PureImplementation& impl)
: IGSortedBagAsBstTree
   <Element, ICOps <Element> > (impl)
{
}


// ---
// IVGSortedBagAsBstTree
// ---

// public members

template <class Element, class ElementOps>
inline
IVGSortedBagAsBstTree <Element, ElementOps>::
IVGSortedBagAsBstTree (INumber numberOfElements)
: IGSortedBagAsBstTree
    <Element, ElementOps> (*(Implementation*) *new




                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class ElementOps>
inline
IVGSortedBagAsBstTree <Element, ElementOps>::
IVGSortedBagAsBstTree (PureImplementation& impl)
: IGSortedBagAsBstTree
    <Element, ElementOps> (impl)
{
}

// ---
// IVSortedBagAsBstTree
// ---

// public members

template <class Element>
inline
IVSortedBagAsBstTree <Element>::
IVSortedBagAsBstTree (INumber numberOfElements)
: IVGSortedBagAsBstTree
   <Element, ICOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IVSortedBagAsBstTree <Element>::
IVSortedBagAsBstTree (PureImplementation& impl)
: IVGSortedBagAsBstTree
   <Element, ICOps <Element> > (impl)
{
}


#endif // _ISBBST_INL_
