// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 89 1.4.1.4 source/core/collect/isblst.inl, collection, ioc.v400, 981126  
#ifndef _ISBLST_INL_
#define _ISBLST_INL_

// ---
// IGSortedBagAsListCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class ElementOps>
inline
IGSortedBagAsListCursor <Element, ElementOps>::
IGSortedBagAsListCursor
  (IGSortedBagAsList
    <Element, ElementOps> const& collection)
: IOrderedCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class ElementOps>
inline IGSortedBagAsListCursor <Element, ElementOps>&
IGSortedBagAsListCursor <Element, ElementOps>::
operator=
  (IGSortedBagAsListCursor
    <Element, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGSortedBagAsListCursor <Element, ElementOps>::
IGSortedBagAsListCursor (ICursorImpl* impl)
: IOrderedCursor <Element> (impl)
{
}






























// ---
// IGSortedBagAsList
// ---

// public members

template <class Element, class ElementOps>
inline
IGSortedBagAsList <Element, ElementOps>::
IGSortedBagAsList (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new




                Instantiation (numberOfElements));
}

template <class Element, class ElementOps>
inline
IGSortedBagAsList <Element, ElementOps>::
IGSortedBagAsList
  (IGSortedBagAsList
    <Element, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class ElementOps>
inline IGSortedBagAsList <Element, ElementOps>&
IGSortedBagAsList <Element, ElementOps>::
operator= (IGSortedBagAsList
            <Element, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGSortedBagAsList <Element, ElementOps>::
IGSortedBagAsList (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class ElementOps>
inline TYPENAME IGSortedBagAsList
 <Element, ElementOps>::Implementation&
IGSortedBagAsList <Element, ElementOps>::
ImplOf (IGSortedBagAsList
         <Element, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// ISortedBagAsList
// ---

// public members

template <class Element>
inline
ISortedBagAsList <Element>::
ISortedBagAsList (INumber numberOfElements)
: IGSortedBagAsList
   <Element, ICOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
ISortedBagAsList <Element>::
ISortedBagAsList (PureImplementation& impl)
: IGSortedBagAsList
   <Element, ICOps <Element> > (impl)
{
}


// ---
// IVGSortedBagAsList
// ---

// public members

template <class Element, class ElementOps>
inline
IVGSortedBagAsList <Element, ElementOps>::
IVGSortedBagAsList (INumber numberOfElements)
: IGSortedBagAsList
    <Element, ElementOps> (*(Implementation*) *new




                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class ElementOps>
inline
IVGSortedBagAsList <Element, ElementOps>::
IVGSortedBagAsList (PureImplementation& impl)
: IGSortedBagAsList
    <Element, ElementOps> (impl)
{
}

// ---
// IVSortedBagAsList
// ---

// public members

template <class Element>
inline
IVSortedBagAsList <Element>::
IVSortedBagAsList (INumber numberOfElements)
: IVGSortedBagAsList
   <Element, ICOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IVSortedBagAsList <Element>::
IVSortedBagAsList (PureImplementation& impl)
: IVGSortedBagAsList
   <Element, ICOps <Element> > (impl)
{
}


#endif // _ISBLST_INL_
