// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 94 1.4.1.4 source/core/collect/isbtab.inl, collection, ioc.v400, 981126  
#ifndef _ISBTAB_INL_
#define _ISBTAB_INL_

// ---
// IGSortedBagAsTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class ElementOps>
inline
IGSortedBagAsTableCursor <Element, ElementOps>::
IGSortedBagAsTableCursor
  (IGSortedBagAsTable
    <Element, ElementOps> const& collection)
: IOrderedCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class ElementOps>
inline IGSortedBagAsTableCursor <Element, ElementOps>&
IGSortedBagAsTableCursor <Element, ElementOps>::
operator=
  (IGSortedBagAsTableCursor
    <Element, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGSortedBagAsTableCursor <Element, ElementOps>::
IGSortedBagAsTableCursor (ICursorImpl* impl)
: IOrderedCursor <Element> (impl)
{
}






























// ---
// IGSortedBagAsTable
// ---

// public members

template <class Element, class ElementOps>
inline
IGSortedBagAsTable <Element, ElementOps>::
IGSortedBagAsTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new




                Instantiation (numberOfElements));
}

template <class Element, class ElementOps>
inline
IGSortedBagAsTable <Element, ElementOps>::
IGSortedBagAsTable
  (IGSortedBagAsTable
    <Element, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class ElementOps>
inline IGSortedBagAsTable <Element, ElementOps>&
IGSortedBagAsTable <Element, ElementOps>::
operator= (IGSortedBagAsTable
            <Element, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGSortedBagAsTable <Element, ElementOps>::
IGSortedBagAsTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class ElementOps>
inline TYPENAME IGSortedBagAsTable
 <Element, ElementOps>::Implementation&
IGSortedBagAsTable <Element, ElementOps>::
ImplOf (IGSortedBagAsTable
         <Element, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// ISortedBagAsTable
// ---

// public members

template <class Element>
inline
ISortedBagAsTable <Element>::
ISortedBagAsTable (INumber numberOfElements)
: IGSortedBagAsTable
   <Element, ICOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
ISortedBagAsTable <Element>::
ISortedBagAsTable (PureImplementation& impl)
: IGSortedBagAsTable
   <Element, ICOps <Element> > (impl)
{
}


// ---
// IVGSortedBagAsTable
// ---

// public members

template <class Element, class ElementOps>
inline
IVGSortedBagAsTable <Element, ElementOps>::
IVGSortedBagAsTable (INumber numberOfElements)
: IGSortedBagAsTable
    <Element, ElementOps> (*(Implementation*) *new




                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class ElementOps>
inline
IVGSortedBagAsTable <Element, ElementOps>::
IVGSortedBagAsTable (PureImplementation& impl)
: IGSortedBagAsTable
    <Element, ElementOps> (impl)
{
}

// ---
// IVSortedBagAsTable
// ---

// public members

template <class Element>
inline
IVSortedBagAsTable <Element>::
IVSortedBagAsTable (INumber numberOfElements)
: IVGSortedBagAsTable
   <Element, ICOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IVSortedBagAsTable <Element>::
IVSortedBagAsTable (PureImplementation& impl)
: IVGSortedBagAsTable
   <Element, ICOps <Element> > (impl)
{
}


#endif // _ISBTAB_INL_
