#ifndef _ISEQ2_C_
#define _ISEQ2_C_
/*******************************************************************************
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*                                                                              *
*******************************************************************************/
#include <iseq2.h>

template <class Element, class Imp>
  ITImpSequence< Element, Imp>::ITImpSequence( unsigned long numberOfElements)
       : fNumberOfElements(numberOfElements)
{}

template <class Element, class Imp>
  ITImpSequence< Element, Imp>::~ITImpSequence( )
{}

template <class Element>
  ISequence< Element>::ISequence( unsigned long numberOfElements )
      : ITImpSequence< Element, Element>( numberOfElements)
{}

template <class Element>
  ISequence< Element>::~ISequence( )
{}


template <class Element>
  IVSequence< Element>::IVSequence( unsigned long numberOfElements )
      : ITImpSequence< Element, Element>( numberOfElements)
{}

template <class Element>
  IVSequence< Element>::~IVSequence( )
{}



#ifdef IC_USE_STL_VPTR
  template <class Element>
    IVPtrSequence< Element>::IVPtrSequence( unsigned long numberOfElements )
        : ITImpSequence< Element, void*>( numberOfElements)
  {}

  template <class Element>
    IVPtrSequence< Element>::~IVPtrSequence( )
  {}
#endif

#endif // _ISEQ2_C_
